
using System;
using System.Text;
using System.IO;
using System.Net.Sockets;

public class Server
{
  public static void Main ( String[] args )
  {
    if ( args.Length != 1 )
    {
      Console.WriteLine ( "Usage: Server.exe <count>" );
      Console.WriteLine ();
      Console.WriteLine ( "  <count>       - integer, the algorithm generates <count> customers, " );
      Console.WriteLine ( "                           <count>*2 contacts, and <count>*4 phone numbers" );
    }
    else
    {
      int numberOfCustomers = Convert.ToInt32 ( args[0] );
    
      String[] customers = new String[numberOfCustomers];
      String[] contacts = new String[numberOfCustomers * 2];
      String[] phones = new String[numberOfCustomers * 4];
      for ( int i = 0; i < numberOfCustomers; i++ )
      {
        customers[i] = "Customer" + i;
        contacts[i * 2] = i + ":Contact" + (i * 2);
        contacts[i * 2 + 1] = i + ":Contact" + (i * 2 + 1);
        phones[i * 4] = (i * 2) + ":Phone" + (i * 4);
        phones[i * 4 + 1] = (i * 2) + ":Phone" + (i * 4 + 1);
        phones[i * 4 + 2] = (i * 2 + 1) + ":Phone" + (i * 4 + 2);
        phones[i * 4 + 3] = (i * 2 + 1) + ":Phone" + (i * 4 + 3);
      }
     
      // Begin: Debug
      for ( int i = 0; i < numberOfCustomers; i++ )
        Console.WriteLine ( customers[i] );
      for ( int i = 0; i < numberOfCustomers * 2; i++ )
        Console.WriteLine ( contacts[i] );
      for ( int i = 0; i < numberOfCustomers * 4; i++ )
        Console.WriteLine ( phones[i] );
      // End: Debug
    
      TcpListener listener = new TcpListener ( 4711 );
      Console.WriteLine ( "starting listener on port 4711..." );
      listener.Start ();
      Console.WriteLine ( "listener waits for client connection..." );
      TcpClient server = listener.AcceptTcpClient ();
      Console.WriteLine ( "client connection accepted" );
      
      NetworkStream output = server.GetStream ();
      StreamReader input = new StreamReader ( output );
      
      String request = input.ReadLine ();
      while ( ( request != null ) && !request.Equals ( "" ) )
      {
        //Console.WriteLine ( "request received: " + request );
        String[] req = request.Split ( new Char[] {':'} );
  
        String what = req[0].ToUpper ();
        int index = Convert.ToInt32 ( req[1] );
  
        String result = null;
        if ( what.Equals ( "CUSTOMER" ) )
          result = customers[index];
        else if ( what.Equals ( "CONTACT" ) )
          result = contacts[index];
        else if ( what.Equals ( "PHONE" ) )
          result = phones[index];
        
        Byte[] res = Encoding.ASCII.GetBytes ( (result + "\n").ToCharArray () );
        output.Write ( res, 0, res.Length );
        
        request = input.ReadLine ();
      }
      
      Console.WriteLine ( "stopping listener..." );
      listener.Stop ();
      Console.WriteLine ( "closing server..." );
      server.Close ();
    }
  }
}